<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Razmotrimo sada koje su dobre strane a koje loše opisanog pristupa.</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  double a = (ye−ys)/(double)(xe−xs);
  double b = -a∗xs + ys ;

  for(int x=xs; x&lt;=xe; x++) {
    int y = zaokruzi(a∗x+b);
    osvijetli_pixel(x,y);
  }
}
</pre>

<p>Interaktivna demonstracija u nastavku sada je proširena tako da omogućava zadavanje početne i konačne točke.</p>

  <p>Isprobajte nacrtati sljedeće linije ovim algoritmom:</p>
  <ol>
    <li>drawLine(1,1,17,8): kut je između 0° i 45°</li>
    <li>drawLine(1,8,17,1): kut je između -45° i 0°</li>
    <li>drawLine(1,1,8,17): kut je između 45° i 90°</li>
    <li>drawLine(8,17,1,1): x-koordinata se smanjuje</li>
  </ol>
  <p>Možete li objasniti ponašanje algoritma za slučajeve 3 i 4?</p>
  <p>Kako bismo trebali modificirati algoritam za dobro radi za slučaj 3?</p>
  <p>Kako bismo trebali modificirati algoritam za dobro radi za slučaj 4?</p>

  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas1" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData1 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas1 = new RasterDisplay("myCanvas1", 20, 20);
    var alg1 = new BresenhamAlgorithm1(lineData1, brcanvas1);
    brcanvas1.idealLineData = lineData1;
    brcanvas1.paint();
  </script>
  drawLine(<input type="text" id="line1_x0" value="1" size="2">, <input type="text" id="line1_y0" value="1" size="2">, <input type="text" id="line1_x1" value="17" size="2">, <input type="text" id="line1_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line1',lineData1)) {alg1.reset(); document.getElementById('alg1btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg1.reset(); document.getElementById('alg1btn').disabled=false;">Reset</button>
  <button id="alg1btn" onclick="alg1.next(); if(!alg1.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg1ch1" type="checkbox" onclick="brcanvas1.showIdealLine = document.getElementById('alg1ch1').checked ? true : false; brcanvas1.paint();"> Prikaz idealne linije

<p>Ako ste isprobali dane primjere, uočili ste sljedeće nedostatke.</p>
<ul>
<li>Dobro radi samo za pravce koji su pod kutevima između -45° i +45°.</li>
<li>Radimo s decimalnim brojevima.</li>
<li>Koristi množenje decimalnih brojeva što je vrlo skupa operacija.</li>
</ul>

<p>Od posebnog je interesa slučaj 3: koeficijent smjera pravca je veći od 1, što znači da se za svaki pomak po osi x, linija po osi y pomakne za više od jednog slikovnog elementa. Rezultat toga je rupičasti prikaz, odnosno dobiven je niz nepovezanih slikovnih elemenata.</p>

<p>Opisani se problem može riješiti tako da se koristi nova inačica algoritma koje se neće pomicati po osi x a računati vrijednosti koordinate y, već upravo suprotno: jednadžbu pravca predstavit ćemo u obliku:
\[
  x = c \cdot y + d
\]
i potom ćemo se pomicati po rasponu vrijednosti koordinate y a izrazom računati vrijednosti koordinate x. Ovdje valja primijetiti da su koeficijenti \(a\) i \(c\) recipročni pa ako je \(a &gt; 1\), tada je sigurno \(c &lt; 1\). Da je to istina, lagano se uvjeriti. Označimo s \(\alpha\) kut koji linija zatvara s osi x. Kut koji ista zatvara s osi y tada je \(90-\alpha\). Pa ako je \(\alpha &gt; 45\) što bi odgovaralo slučaju kada je \(a &gt; 1\), tada je \(90-\alpha &lt; 45\) što za posljedicu ima \(c &lt; 1\).</p>

